Page MenuHomePhabricator

Enable DiscussionTools on pages where `__NEWSECTIONLINK__` is present
Closed, ResolvedPublic

Description

This task is about making sure DiscussionTools are available on pages that meet the criteria listed below.

It is a part of our larger effort to make sure DiscussionTools tools appear on pages editors expect.

Criteria

DiscussionTools should be available on any page that meets the following criteria:

  • Discussions are happening on this page, as evidenced by there being at least one comment on the page.
  • The page is not in a talk namespace
  • The page contains the following syntax __NEWSECTIONLINK__

Done

  • The Reply tool is available on pages that meeting the above "Criteria"

Related Objects

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptFeb 21 2020, 11:18 PM
JTannerWMF added a subscriber: JTannerWMF.

Thank you for capturing this @Lofhi. This is a great idea, we will revisit this when Replying is enabled as default on some wikis.

Other previously discussed possibilities, I think, would include

  • allowing this to be enabled or disabled for pages with a certain prefix (e.g. all subpages of Wikipedia:Articles for deletion)
  • recognizing discussions automatically (e.g. by detecting signatures on every page with the default content model regardless of namespace)
  • using the magic word to indicate a discussion type (e.g. #::::-format indentation, or the future equivalent if the syntax changes, for votes) and/or other metadata

There is a magic indicator: __NEWSECTIONLINK__

In German Wikipedia, all forum pages e.g. in project namespace are equipped with that switch, but no encyclopedic article or non-discussion page does offer this capabilty. In archives this will be revocated. Terminated discussions receive __NOEDITSECTION__ and __NONEWSECTIONLINK__ switches.

The page properties can be retrieved easily from database field.

I do admit that this does not work in English Wikipedia on Wikipedia:Articles for deletion due to the specific transclusion system, but Wikipedia:Village pump would be identified. I guess that in most wikis NEWSECTIONLINK is a good assumption which does not need to change all such pages by a new magic word.

However, a new __EXPECTTALK__ might be introduced for rare exceptions, and classification as talk page might be retrieved from namespace number, NEWSECTIONLINK etc., EXPECTTALK and perhaps NOTALKPAGE.

I would not try to guess character of a talk page from content:

  • As long no one made the first contribution there is neither signature nor indentation.
  • False positives might be assigned to regular textpages.
Alsee added a subscriber: Alsee.Mar 8 2020, 9:21 AM

There should be two magic words. One to enable Discussion Tool, and one to disable Discussion Tool. The magic words would each override the namespace.

Alsee renamed this task from Allow non talk pages to be treated as talk pages using a magic word to Allow non talk pages to be treated as talk pages using a magic word, and allow talk pages to be treated as non-talk pages using a magic word.Mar 8 2020, 9:23 AM

The magic words would each override the namespace.

They should be able to override the guess.

  • However, the guess should be taken from both namespace and NEWSECTIONLINK (NONEWSECTIONLINK) to avoid tremendous insertion of new magic words within existing pages.

But yes, as I suggested above, a __NOTALKPAGE__ might revocate continuation of closed discussions in archives, and NOTALKPAGE should override EXPECTTALK and namespace and any other.

Alsee added a comment.Mar 10 2020, 8:10 AM

I don't know whether any projects use NEWSECTIONLINK on nontalk pages, although EnWiki gets a low but steady occurrence of them in article space due to VisualEditor and the potentially unclear purpose of it. I just removed NEWSECTIONLINK from 35 articles.

That might happen by incident, but you cannot prevent on millions of pages that people introduce inappropriate syntax, declare a regular article as disambiguation page or empty the entire content. Projects are patrolling on a regular base and fix such mislead stuff, or search and rescue the John Hopkins University once a quarter.

Namespace guess rule might be extended to nonzero even namespace number where NEWSECTIONLINK will trigger pseudo talk page behaviour.

We definitely want to add something like this, but I think we should only try to implement it if/when DiscussionTools are enabled by default, otherwise some editors would be angry at us for polluting pages with syntax that doesn't do anything for most people.

Well, the first guess does not change any page:

  • If namespace is even and 2, 4, or >90 and there is NEWSECTIONLINK but no NONEWSECTIONLINK then regard this as a forum.
  • If namespace is odd and there is NONEWSECTIONLINK then do not permit to extend a thread.

The new keywords to equip rare exceptions where the guess fails may be introduced at a later stage. Therfore no page can be changed for those now.

Samat added a subscriber: Samat.Mar 31 2020, 7:47 PM

Looking through the pages that use __NEWSECTIONLINK__ on en.wiki it appears that they are all pages being used as talk pages (mostly in the "Wikipedia" namespace): https://w.wiki/Lkc. The same appears to be true on other wikis. If there are edge cases they're probably a tiny fraction, and even if we do end up loading DiscussionTools on a few non-talk pages, it's not a big performance issue.

I think treating __NEWSECTIONLINK__ pages as talk pages is a pretty sensible first step to take before considering if we need new magic words.

Change 585224 had a related patch set uploaded (by Esanders; owner: Esanders):
[mediawiki/extensions/DiscussionTools@master] Treat pages with __NEWSECTIONLINK__ as talk pages

https://gerrit.wikimedia.org/r/585224

We probably need a "both/and" approach instead of an "either/or" approach here. __NEWSECTIONLINK__ is an excellent signal, but it isn't present on deletion discussion pages. Editors have already requested the ability to use the Reply tool in deletion discussions, and I think will be expected at all of the larger wikis. So if we enable it in the Project: namespace plus whenever __NEWSECTIONLINK__ is present, that will likely cover all the wanted pages.

We probably need a "both/and" approach instead of an "either/or" approach here. __NEWSECTIONLINK__ is an excellent signal, but it isn't present on deletion discussion pages. Editors have already requested the ability to use the Reply tool in deletion discussions, and I think will be expected at all of the larger wikis. So if we enable it in the Project: namespace plus whenever __NEWSECTIONLINK__ is present, that will likely cover all the wanted pages.

We'll discuss that on T249180

Change 585224 merged by jenkins-bot:
[mediawiki/extensions/DiscussionTools@master] Treat pages with __NEWSECTIONLINK__ as talk pages

https://gerrit.wikimedia.org/r/585224

ppelberg added a subscriber: Dyolf77_WMF.EditedApr 2 2020, 11:53 PM

To summarize, here is the initial approach we are taking to enabling DiscussionTools in non-talk namespaces...

Now

Approach
To broaden the number of pages where people can use DiscussionTools, we will enable them wherever any of the following conditions are met:

  • _NEWSECTIONLINK__ is present on the page, regardless of the namespace
  • The page is in a talk namespace

The above is implemented in T245890#6024714. [1]

Rationale
There is a high likelihood pages containing __NEWSECTIONLINK__ have discussions on them and for those that do not, we are assuming enabling DT on these pages will have negligible impact on people reading/editing pages of this sort [2]. "Negligible impact" meaning it is unlikely pages will take any longer to load and new discussion features will not be a distraction considering they won't be visible (unless, of course, signatures are present).

The above is evidenced by reviewing a sample of pages from the results linked below. See: T245890#6018660 for more info.

Open question

  • @Samat & @Dyolf77_WMF, what do you both think of the effectiveness of the approach above? I ask considering there seems to be a relatively small number of pages on ar.wiki and hu.wiki using __NEWSECTIONLINK__.

Next

To expand the scope of pages where DiscussionTools are available for people to use [3], investigate whether $wgExtraSignatureNamespaces being enabled is a strong signal conversations are happening: T249180.

Later

Approach
To decrease the likelihood of DiscussionTools being enabled on pages where they should not be (e.g. archived talk pages), expand T245890#6024714 to include logic that will disable DiscussionTools if any of the conditions below are true:

  • __NONEWSECTIONLINK__ is present regardless of the namespace: T249293
  • A yet-to-be-determined explicit override is present: T249293

Note: further investigation is needed before either of the conditions above are implemented.


  1. @Esanders, if T245890#6024714 behave differently from how I've described it above, please let me know.
  2. E.g. user (enw.wiki) sandbox (fr.wiki) pages
  3. E.g. on project page subpages, as @Jc86035 mentions in T249036#6018680

Open question

  • @Samat & @Dyolf77_WMF, what do you both think of the effectiveness of the approach above? I ask considering there seems to be a relatively small number of pages on ar.wiki and hu.wiki using __NEWSECTIONLINK__.

@ppelberg well, this is already a good effective and sufficient approach.
The number of pages on ar.wiki can be adjusted. I have no doubt that the community will be able to review more pages and add the word for those that are deemed adequate to receive __NEWSECTIONLINK__/the reply tool. So far I have only seen positive feedback about it.

ppelberg added a comment.EditedApr 3 2020, 10:52 PM

Open question

  • @Samat & @Dyolf77_WMF, what do you both think of the effectiveness of the approach above? I ask considering there seems to be a relatively small number of pages on ar.wiki and hu.wiki using __NEWSECTIONLINK__.

@ppelberg well, this is already a good effective and sufficient approach.
The number of pages on ar.wiki can be adjusted. I have no doubt that the community will be able to review more pages and add the word for those that are deemed adequate to receive __NEWSECTIONLINK__/the reply tool. So far I have only seen positive feedback about it.

Excellent. Thank you for confirming, @Dyolf77_WMF. We'll continue to assume using the presence of __NEWSECTIONLINK__ on ar.wiki pages is a signal that DiscussionTools should be enabled on them.

Open question

  • @Samat...what do you both think of the effectiveness of the approach above? I ask considering there seems to be a relatively small number of pages on ar.wiki and hu.wiki using __NEWSECTIONLINK__.

Copying over the comments @Samat shared on MediaWiki [1]:

"I am not completely sure yet. I've checked the pages where we use this magic word now, and majority of them are not real discussion pages. If the decision will be, that the __NEWSECTIONLINK__ is connected to the Reply tool, we need to reconsider how we use it and clean up the wiki before we introduce this feature."


  1. https://www.mediawiki.org/w/index.php?title=Topic:Vjxycppfwer4qmrm&topic_showPostId=vk2wez997uqwczfv#flow-post-vk2wez997uqwczfv

The reply tool is active now on the Dutch Wikipedia in the Village Pump, see: https://nl.wikipedia.org/wiki/Overleg_Wikipedia:Discussietools.
However is not yet active in AfD, see: https://nl.wikipedia.org/wiki/Wikipedia:Te_beoordelen_pagina%27s

The reply tool is active now on the Dutch Wikipedia in the Village Pump, see: https://nl.wikipedia.org/wiki/Overleg_Wikipedia:Discussietools.

Excellent. Thank you, @AdHuikeshoven. If you, or anyone else notices the tool behaving in unexpected ways, please let us know.

And just to confirm, the Dutch Wikipedia's Village Pump is located at https://nl.wikipedia.org/wiki/Help:Helpdesk, right?

I ask because the link above led me to: https://nl.wikipedia.org/wiki/Wikipedia:Discussietools.

However is not yet active in AfD, see: https://nl.wikipedia.org/wiki/Wikipedia:Te_beoordelen_pagina%27s

Is there a particular discussion or aspect of this page you think we should be reviewing?

And just to confirm, the Dutch Wikipedia's Village Pump is located at https://nl.wikipedia.org/wiki/Help:Helpdesk, right?

No, the Helpdesk is at that url. The Village Pump is at: https://nl.wikipedia.org/wiki/Wikipedia:De_kroeg

On https://nl.wikipedia.org/wiki/Wikipedia:Te_beoordelen_pagina%27s:

Is there a particular discussion or aspect of this page you think we should be reviewing?

The actual discussions are transcluded from subpages, so T250540 becomes relevant for that page as well.

No, the Helpdesk is at that url. The Village Pump is at: https://nl.wikipedia.org/wiki/Wikipedia:De_kroeg

I see now – thank you for clarifying, @AdHuikeshoven.

On https://nl.wikipedia.org/wiki/Wikipedia:Te_beoordelen_pagina%27s:

Is there a particular discussion or aspect of this page you think we should be reviewing?

The actual discussions are transcluded from subpages, so T250540 becomes relevant for that page as well.

Oh, I understand. We're thinking it would be worthwhile to test enabling the Reply tool in namespaces where the signature button [i] is enabled. This way, Reply links could be visible without needing the "New section" to be available as well which would help avoid the issue T250540 describes from happening on https://nl.wikipedia.org/wiki/Wikipedia:Te_beoordelen_pagina%27s.

Which creates a question for you, @AdHuikeshoven: Can you think of reasons why it might not be a good idea to enable the Replying tool in namespaces where the signature button is available?


Note: I've copied the question above from T249036#6073955.

ppelberg renamed this task from Allow non talk pages to be treated as talk pages using a magic word, and allow talk pages to be treated as non-talk pages using a magic word to Enable DiscussionTools on pages not in a talk namespace.Apr 22 2020, 2:34 AM
ppelberg updated the task description. (Show Details)
Jony added a subscriber: Jony.Apr 22 2020, 5:59 AM

Which creates a question for you, @AdHuikeshoven: Can you think of reasons why it might not be a good idea to enable the Replying tool in namespaces where the signature button is available?

@ppelberg not yet. I'll post the question on nl.wp

Which creates a question for you, @AdHuikeshoven: Can you think of reasons why it might not be a good idea to enable the Replying tool in namespaces where the signature button is available?

@ppelberg not yet. I'll post the question on nl.wp

Excellent. Thank you, @AdHuikeshoven. I've indicated that you will be posting on nl.wp in the description of T250886.

Samat added a comment.Apr 25 2020, 3:04 PM

@Samat & @Dyolf77_WMF, what do you both think of the effectiveness of the approach above? I ask considering there seems to be a relatively small number of pages on ar.wiki and hu.wiki using NEWSECTIONLINK.

Sorry for the very late reply. I will clean up the pages using NEWSECTIONLINK tomorrow.

@Samat & @Dyolf77_WMF, what do you both think of the effectiveness of the approach above? I ask considering there seems to be a relatively small number of pages on ar.wiki and hu.wiki using NEWSECTIONLINK.

Sorry for the very late reply. I will clean up the pages using NEWSECTIONLINK tomorrow.

No worries – sounds great. Thank you, @Samat.

This task needs to be resolved and a new parent task should take its place @ppelberg. Once Ppelberg cleans this up and make QA clear it can be moved.

Samat added a comment.Apr 29 2020, 9:09 PM

I like that the tool does not appear on pages with NEWSECTIONLINK where there is no discussion. I haven't seen any problem with it until now.

ppelberg renamed this task from Enable DiscussionTools on pages not in a talk namespace to Enable DiscussionTools on pages where `__NEWSECTIONLINK__` is present.May 2 2020, 12:31 AM
ppelberg updated the task description. (Show Details)

This task needs to be resolved and a new parent task should take its place @ppelberg. Once Ppelberg cleans this up and make QA clear it can be moved.

Done. Changes:

  • Task renamed.
  • Task description updated.
  • New parent task created: T251653

I like that the tool does not appear on pages with NEWSECTIONLINK where there is no discussion.

Excellent. Thank you for letting us know, @Samat.

And just to be sure, by saying, "I haven't seen any problem with it until now." are you saying you have not observed any issues so far?

Samat added a comment.May 2 2020, 9:09 AM

And just to be sure, by saying, "I haven't seen any problem with it until now." are you saying you have not observed any issues so far?

Exactly, this is what I meant. The tool works well where it should and doesn't work where it should not.

The only thing came into my mind: how can a user start a discussion on pages where the tool is not visible because of lack of signatures (but available in the background)?

The only thing came into my mind: how can a user start a discussion on pages where the tool is not visible because of lack of signatures (but available in the background)?

That will be part of our new discussion tool which we have started work on: https://www.mediawiki.org/wiki/Talk_pages_project/New_discussion

Samat added a comment.May 2 2020, 2:13 PM

That will be part of our new discussion tool which we have started work on: https://www.mediawiki.org/wiki/Talk_pages_project/New_discussion

Awesome, thank you!

Esanders claimed this task.Jun 4 2020, 2:43 PM
Esanders moved this task from Inbox to Low Priority on the Editing QA board.
ppelberg edited projects, added Skipped QA; removed Editing QA.Thu, Nov 5, 10:56 PM
ppelberg closed this task as Resolved.Fri, Nov 6, 3:00 AM